<?php
/*
 * PHP RPN (Reverse Polish notation) calculator
 *
 * created on rrdtool rpn scheme
 * not all functions impelented yet
 *
 * by johnrembo@netzond.com
 */



/*  
 * retrieve values in stack and replace them with single result value.
 * $type: number of values to be replaced with single result value (1,2,3)
 * $stack - aray where values to be replaced are stored
 * $i - stack array internal pointer position
 * $tmp_val - replacement value
 */
function d($type) {
    global $stack, $i, $tmp_val;
    switch ($type) {
	case 1://OP_FLOOR
	    unset($stack[$i-1]);//pop last array value
	    $i=$i-1;		//decrease internal pointer
	    $stack[$i]=$tmp_val;//save data in previous stack element
	    break;
	case 2://OP_ADD
	    unset($stack[$i-1],$stack[$i-2]);
	    $i=$i-2;
	    $stack[$i]=$tmp_val;
	    break;
	case 3://OP_IF
	    unset($stack[$i-1],$stack[$i-2]);
	    $i=$i-3;
	    $stack[$i]=$tmp_val;
	    break;	    
    }
}

/*
 * calculate rpn string ($task)
 * $print - enables debug output
 */
function rpn_calc($task,$print=false) {
  global $stack, $i, $tmp_val;

  $operator = array(
		    '+' => 'OP_ADD',
		    '-' => 'OP_SUB',
		    '*' => 'OP_MUL',
		    '/' => 'OP_DIV',
		    '%' => 'OP_MOD',
		    
		    'FLOOR' => 'OP_F',
		    'CEIL'  => 'OP_C',
		    
		    'SIN' => 'OP_SIN', 
		    'COS' => 'OP_COS',
		    'LOG' => 'OP_LOG',
		    'EXP' => 'OP_EXP',
		    'SQRT'=> 'OP_SQRT',
		    'ATAN' => 'OP_AT',
		    'ATAN2' => 'OP_AT2',
		    'DEG2RAD' => 'OP_D2R',
		    'RAD2DEG' => 'OP_R2D',
		    'ABS' => 'OP_ABS',
		    
		    'LT' => 'OP_LT',
		    'LE' => 'OP_LE',
		    'GT' => 'OP_GT',
		    'GE' => 'OP_GE',
		    'EQ' => 'OP_EQ',
		    'NE' => 'OP_NE',
		    
		    'MIN' => 'OP_MIN',
		    'MAX' => 'OP_MAX',
		    'LIMIT' => 'OP_LIM',
		    'IF' => 'OP_IF',
		    'TIME' => 'OP_TIME',
		    'UN' => 'OP_UN'
		    );
  

  $queue = explode(',',$task);

  $items = array();
  $type='';
  $i=0;
    
  foreach ($queue as $value) {
    if (isset($operator[$value])) {
	//OPERATOR DETECTED
        if ($print) echo "processing math operation:\t$value\n";
	switch ($operator[$value]) {
	    //ARITHMETIC OPERATIONS
	    case 'OP_ADD':
		$tmp_val= $stack[$i-2] + $stack[$i-1];d(2);
		break;
	    case 'OP_SUB':
		$tmp_val= $stack[$i-2] - $stack[$i-1];d(2);
		break;
	    case 'OP_MUL':
		$tmp_val= $stack[$i-2] * $stack[$i-1];d(2);
		break;
	    case 'OP_DIV':
		if ($stack[$i-1] == 0) //correct division by zero error in false rpn
		    $tmp_val = 0;
		else 
		    $tmp_val= $stack[$i-2] / $stack[$i-1];d(2);
		break;	
	    case 'OP_MOD':
		$tmp_val= $stack[$i-2] % $stack[$i-1];d(2);
		break;
	    case 'OP_F':
		$tmp_val= floor($stack[$i-1]);d(1);
		break;
	    case 'OP_C':
		$tmp_val= ceil($stack[$i-1]);d(1);
		break;
	    case 'OP_SIN':
		$tmp_val= sin($stack[$i-1]);d(1);
		break;	
	    case 'OP_COS':
		$tmp_val= cos($stack[$i-1]);d(1);
		break;
	    case 'OP_AT':
		$tmp_val= atan($stack[$i-1]);d(1);
		break;
	    case 'OP_AT2':
		$tmp_val= atan2($stack[$i-2],$stack[$i-1]);d(2);
		break;
	    case 'OP_LOG':
		$tmp_val= log($stack[$i-1]);d(1);
		break;
	    case 'OP_EXP':
		$tmp_val= exp($stack[$i-1]);d(1);
		break;
	    case 'OP_SQRT':
		$tmp_val= sqrt($stack[$i-1]);d(1);
		break;
	    case 'OP_R2D':
		$tmp_val= rad2deg($stack[$i-1]);d(1);
		break;
	    case 'OP_D2R':
		$tmp_val= deg2rad($stack[$i-1]);d(1);
		break;
	    case 'OP_ABS':
		$tmp_val= abs($stack[$i-1]);d(1);
		break;
	    //BOOLEAN OPERATIONS
	    case 'OP_LT':
		$tmp_val = $stack[$i-2] < $stack[$i-1] ? 1 : 0;d(2);
		break;
	    case 'OP_LE':
		$tmp_val = $stack[$i-2] <= $stack[$i-1] ? 1 : 0;d(2);
		break;
	    case 'OP_GT':
		$tmp_val = $stack[$i-2] > $stack[$i-1] ? 1 : 0;d(2);
		break;
	    case 'OP_GE':
		$tmp_val = $stack[$i-2] >= $stack[$i-1] ? 1 : 0;d(2);
		break;	
	    case 'OP_EQ':
		$tmp_val= $stack[$i-2] == $stack[$i-1] ? 1 : 0;d(2);
		break;
	    case 'OP_NE':
		$tmp_val = $stack[$i-2] != $stack[$i-1] ? 1 : 0;d(2);
		break;
	    //SELECTIVE & CONDITIONAL OPERATORS
	    case 'OP_MIN':
		$tmp_val = $stack[$i-2] < $stack[$i-1] ? $stack[$i-2] : $stack[$i-1];d(2);
		break;
	    case 'OP_MAX':
		$tmp_val = $stack[$i-2] > $stack[$i-1] ? $stack[$i-2] : $stack[$i-1];d(2);
		break;
	    case 'OP_LIM':
		if (($stack[$i-3] >= $stack[$i-2]) && ($stack[$i-3] <= $stack[$i-1]))
		    $tmp_val = $stack[$i-3];
		else 
		    $tmp_val = 'UN';
		d(3);
		break;
	    case 'OP_IF':
		$tmp_val = $stack[$i-3] != 0 ? $stack[$i-2] : $stack[$i-1];d(3);
		break;
	    case 'OP_TIME':
		$tmp_val = $stack[$i] = strtotime(date('Y-m-d h:i:s'))+(3600*12);
		break;
	    case 'OP_UN':
		$tmp_val = $stack[$i-1] == "U" ? 0 : $stack[$i-1];d(1);
		break;
	}
    } else if (preg_match("/[a-z]+\d*/i",$value)) {
        //VARIABLE DETECTED [a,a2,zz5]
	if ($print) echo "adding variable [$value] at position [$i] to stack\n";
	$stack[$i]=$value;
    } else if (preg_match("/[-+]?[0-9]*\.?[0-9]+/",$value)) {
	//NUMBER DETECTED
	if ($print) echo "adding number [$value] at position [$i] to stack\n";
	$stack[$i]=$value;
    } else {
	die ("unknown variable type [$variable]!");
    }
    $i++;
    if ($print) {echo "printing stack:\n";print_r($stack);}
  }
  return $stack[0];
}

//some test rows:
//echo rpn_calc('TIME,1176448207,GT,5,5,UN,0,5,IF,IF,TIME,1176448207,GT,7,7,UN,0,7,IF,IF,+,1024,*',true);
//echo rpn_calc('TIME,1176723807,GT,4639910,4639910,UN,0,4639910,IF,IF',true);
//echo rpn_calc('TIME,1177065283,GT,1000,1000,UN,0,1000,IF,IF,TIME,1177065283,GT,2000,2000,UN,0,2000,IF,IF,TIME,1177065283,GT,3000,3000,UN,0,3000,IF,IF,+,+',true);
?>