<?php
/*******************************************************************************

    Author ......... johnrembo
    Contact ........ johnrembo@netzond.com
    Home Site ...... http://www.netzond.com
    Program ........ Real-time statistics for cacti
    Purpose ........ World peace

*******************************************************************************/

function plugin_init_zond() {
	global $plugin_hooks;
	$plugin_hooks['config_arrays']['zond'] = 'zond_config_arrays';
	$plugin_hooks['config_settings']['zond'] = 'zond_config_settings';
	$plugin_hooks['graph_buttons']['zond'] = 'zond_graph_buttons';
}

function zond_version () {
	return array( 
			'name' 		=> 'zond',
			'version' 	=> '0.32',
			'longname'	=> 'Real-time statistics',
			'author'	=> 'johnrembo',
			'homepage'	=> 'http://www.netzond.com',
			'email'		=> 'johnrembo@netzond.com',
			'url'		=> 'www.netzond.com/zond'
		    );
}

function zond_config_settings () {
	global $tabs, $settings, $config;
	
	$tabs["zond"] = "Zond";
	
	//cacti plugin architecture is far not perfect, so is html framework
	//All the following mess is just to add simpel onMouseOver and onClick javascript functionalities.
	$js_loader = "<script type=\"text/javascript\">
				var sc_tooltip = document.createElement('script');
				var sc_events = document.createElement('script');
		    		
				sc_tooltip.type = 'text/javascript';
				sc_events.type = sc_tooltip.type;
				
				sc_tooltip.src = 'plugins/zond/js/wz_tooltip.js';
				sc_events.src = 'plugins/zond/js/zond_events.js';
				
				var tb = document.body.childNodes[0];
				tb.parentNode.insertBefore(sc_tooltip,tb);
				tb.parentNode.insertBefore(sc_events,tb);
			</script>";
	
	$tmpl = list_files($config['base_path'].'/plugins/zond/templates/');
	$def_temp = 0;
	$nr = 0;
	
	//read template names from containing directory excluding other files
	foreach ($tmpl as $template) {
	    if (substr($template,-3)!="php") continue;
	    $template_name = substr($template,0,-4);
	    $templates[$nr] = $template_name;
	    if ($template_name == "DEFAULT") $def_temp = $nr;
	    $nr++;
	}
	
	$temp = array(
		    "zond_header"	=>	array(
							"friendly_name" => "${js_loader}Zond configuration",
							"method" => "spacer"
						     ),
		    "zond_enable"	=>	array(
							"friendly_name" => "Enable Zond button on charts",
							"description" => "By checking this you will enable Zond button next to zoom button on previewed graphs",
							"default" => "on",
							"method" => "checkbox"
						     ),
		    "zond_template"	=>	array(  
							"friendly_name" => "ZOND TEMPLATES",
					                "description" => "You can change zond plug-in look by using predefined templates",
							"method" => "drop_array",
							"default" => $def_temp,
							"array" => $templates
						     ),
		    "zond_header2"	=>	array(
							"friendly_name" => "Chart parameters",
							"method" => "spacer"
						     ),
            	    "zond_width" 	=> 	array(
		                    			"friendly_name" => "WIDTH",
					                "description" => "The width of the chart (in pixels)",
							"method" => "textbox",
							"max_length" => "4",
							"size"	=> "3",
							"default" => "700"
						     ),
            	    "zond_height" 	=> 	array(
		                    			"friendly_name" => "HEIGHT",
					                "description" => "The height of the chart (in pixels)<br>It may varry a little because of legends",
							"method" => "textbox",
							"max_length" => "4",
							"size"	=> "3",
							"default" => "250"
						     ),
            	    "zond_autosize" 	=> 	array(
		                    			"friendly_name" => "AUTO SIZE",
					                "description" => "Keep ZOND window size the same as cacti graph window.<br>If disabled - <b>width</b> and <b>height</b> will be used",
							"method" => "drop_array",
							"default" => 0,
							"array" => array(
									 "YES",
									 "NO"
									 )
						     ),
            	    "zond_scaletype" 	=> 	array(
		                    			"friendly_name" => "SCALE TYPE",
					                "description" => "<b>CACTI</b> - uses same scale as cacti does per graph (auto,custom,auto-max).<br><b>ZOND</b> - always uses dynamic min and max Y values.",
							"method" => "drop_array",
							"default" => 0,
							"array" => array(
									 "CACTI",
									 "ZOND"
									 )
						     ),
                    "zond_axis_pos"     =>      array(
                                                        "friendly_name" => "TIME AXIS POSITION",
                                                        "description" => "Choose where to put time axis - on",
                                                        "method" => "drop_array",
                                                        "default" => 1,
                                                        "array" => array("top","bottom")
                                                     ),
            	    "zond_charttype" 	=> 	array(
		                    			"friendly_name" => "CHART TYPE",
					                "description" => "<b>Plots and Lines</b> - ZOND chart same as cacti chart.<br><b>Bars</b> - column style charts.",
							"method" => "drop_array",
							"default" => 0,
							"array" => array(
									 "Plots and Lines",
									 "Bars"
									 )
						     ),

            	    "zond_refresh" 	=> 	array(
		                    			"friendly_name" => "REFRESH",
					                "description" => "The refresh interval of the chart (in miliseconds)<br>Values lower than 1sec. are not recommend",
							"method" => "textbox",
							"max_length" => "5",
							"size"	=> "4",
							"default" => "1500"
						     ),
		    "zond_header4"	=>	array(
							"friendly_name" => "Security parameters",
							"method" => "spacer"
						     ),
            	    "zond_user" 	=> 	array(
		                    			"friendly_name" => "HTTP AUTH LOGIN",
					                "description" => "If cacti is protected with http-authentication - enter login here",
							"method" => "textbox",
							"max_length" => "20",
							"size"	=> "19"
						     ),
            	    "zond_pass" 	=> 	array(
		                    			"friendly_name" => "HTTP AUTH PASSWORD",
					                "description" => "If cacti is protected with http-authentication - enter password here",
							"method" => "textbox",
							"max_length" => "20",
							"size"	=> "19"
						     ),
            	    "zond_hash" 	=> 	array(
		                    			"friendly_name" => "PASSWORD FOR REQUEST ENCRYPTION",
					                "description" => "Secures query information (such as snmp passwords, ip addresses, folder structure) sent by zond applet",
							"method" => "textbox",
							"max_length" => "20",
							"size"	=> "19"
						     ),
            	    "zond_hashed"	=>	array(
		                    			"friendly_name" => "REQUEST ENCRYPTION",
					                "description" => "<b>enable</b> - enable encryption of each ZOND request (not recommended on slow or heavily loaded machines) <br><b>disable</b> - disables ZOND request encryotion (recomended if no outside users uses ZOND plug-in).",
							"method" => "drop_array",
							"default" => 0,
							"array" => array("enable","disable")
						     ),
            	    "zond_hash_blcksize"	=>	array(
		                    			"friendly_name" => "HASH BLOCK SIZE",
					                "description" => "Lower(2,3) is more secure (than 30,50), but slower (especially on hudge graph templates).",
							"method" => "drop_array",
							"default" => 3,
							"array" => array(2,3,5,10,20,30,50)
						     ),
            	    "zond_security"	=>	array(
		                    			"friendly_name" => "SECURITY ENVIRONMENT",
					                "description" => "<b>CACTI</b> - allows use of ZOND plugin only from cacti's web interface(session)<br><b>APPLET</b> - allows direct access to ZOND plug-in only for java applet. Use this option only if other applications display cacti graphs",
							"method" => "drop_array",
							"default" => 0,
							"array" => array("CACTI (strong)","APPLET(poor)")
						     ),
            	    "zond_perusrbtn"	=>	array(
		                    			"friendly_name" => "PER-USER BUTTON",
					                "description" => "<b>enable</b> - allows to enable/disable ZOND button on each user under \"User Management\"<br><b>disable</b> - enables ZOND button for all users.",
							"method" => "drop_array",
							"default" => 0,
							"array" => array("enable","disable")
						     )
		);

	//assign image tooltips to config options considering on option title and image name equivalent
	foreach ($temp as $id => $item) {
	    $curr_img=array();
	    $tooltip='';
	
	    foreach (list_files($config['base_path'].'/plugins/zond/images/settings/') as $image) {
		if (stristr($image, str_replace(" ","_",strtolower($item['friendly_name'])))==true && $id!='zond_header')
		    $tooltip.="<strong>".str_replace("_"," ",substr($image,0,-4))."</strong><br><img src=\'plugins/zond/images/settings/$image\'><br>";
		
	    }
	    if ($tooltip!='')
		$temp[$id]['friendly_name'] = "<a href=\"#\" style='cursor: pointer;' onmouseover=\"Tip('$tooltip')\">".$item['friendly_name']."</a>";
		
	}
	
	if (isset($settings["zond"]))
		$settings["zond"] = array_merge($settings["zond"], $temp);
	else
		$settings["zond"]=$temp;

}

function zond_config_arrays () {
        global $user_auth_realms, $user_auth_realm_filenames;
        $user_auth_realms[71]='ZOND Button next to charts';
		
        $user_auth_realm_filenames['zond_init.php'] = 71;
        $user_auth_realm_filenames['zond_process.php'] = 71;
        $user_auth_realm_filenames['zond_functions.php'] = 71;

}

function zond_graph_buttons ($params) {
    global $config;
    
    if (read_config_option("zond_enable")=="") return;
    
    //adopt window size to java-applet size
    if (read_config_option("zond_autosize")=='0') {
	$w = '180';
	$h = '80';
    } else {
	$w = read_config_option("zond_width");
	$h = read_config_option("zond_height");
    }
    
    $lg_id=$params[1]['local_graph_id'];

    if (!allow('view')) return;
    
    //one of many differences between IE and Other browsers
    $l = ( stristr($_SERVER['HTTP_USER_AGENT'],'msie') || stristr($_SERVER['HTTP_USER_AGENT'],'microsoft') ) ? $l = '' :  $l = 'location=yes,';
    
    //return ZOND button to browser
    echo '<a href=# onClick=\'javascript:wnd=window.open("plugins/zond/zond_init.php?lgid='.$lg_id.'&s_i_d='.session_id().'","'.rand(1,50000).'","menubar=no,toolbar=no,'.$l.'resizable=no,width='.$w.',height='.$h.'");\'>
	      <img border="0" alt="Zond" title="Zond" style="padding: 3px" src="plugins/zond/images/chart.png">
	  </a>';
}


/*
 * check users permissions
 * this function is intended to be expanded on future releases
*/
function allow($task) {
    global $user_auth_realms, $config;
    $result = false;

    if (read_config_option("zond_perusrbtn")=='1')//disable per-user settings check
	return true;
    //using guest acc, opening links directly $_SESSION['sess_user_id'] = !isset
    elseif (!isset($_SESSION["sess_user_id"]))//can't let in guest users 
        return false;

    if (read_config_option("global_auth") == "on") {
        $user_realms = db_fetch_assoc("select realm_id from user_auth_realm where user_id=" . $_SESSION["sess_user_id"]);
        $user_realms = array_rekey($user_realms, "realm_id", "realm_id");
    }else{
        $user_realms = $user_auth_realms;
    }
    
    switch ($task) {
    case 'view':
        if ( isset($user_realms[71]) )
	    $result = true;
	    break;
    default:
	    $result = false;
	    break;
    }
    
    return $result;
}

function list_files($path) {
    if($dh = opendir($path)) {
        while(($file = readdir($dh)) !== false) {
            if($file != "." && $file != ".." && !is_dir($file)) 
    		$result[]=$file;
	    }
	    closedir($dh);
	    return $result;
	}else{
	    return false;
	}
}
?>
