#!/usr/bin/php -q
<?php

/*
 * converts script output to traffic
 * by johnrembo@netzond.com
 */
if (!isset($_SERVER['argc']) || $_SERVER['argc']< 2) {
    echo "error: not enough arguments!\nusage: traffic.php \"command\"\n";
    die;
}

DEFINE('REFRESH_INTERVAL',1);	//[seconds] script_traffic=(script_counter_old+script_counter_new)/refresh_interval
DEFINE('MULTIPLIER',1);		//convert Bytes into Bits (set to 1 to disable conversion)

/*
 * retrieve script data
 * returns array ( 0=>counter_value, 1 => query_time )
 */
function script_data($command) {
    $timePrev=time() + microtime();
	$counter=system("$command");
    $timeNow=time() + microtime() - $timePrev;
    
    $result[]=$counter;
    $result[]=$timeNow;
    
    return $result;
}

$steps = array('prev','curr');
$variables = array();
$command = str_replace("\\$","\$",$_SERVER['argv'][1]);
$result = '';

$counter['prev']=script_data($command);
    sleep(REFRESH_INTERVAL);
$counter['curr']=script_data($command);

if (substr_count($counter['prev'][0]," ")>0) { //if multiple data values are returned
    
    foreach ($steps as $step) {
	$components = explode(" ",trim($counter[$step][0]));
	foreach ($components as $component) {
	    preg_match("/^(.*):([-+]?[0-9]*\.?[0-9]+)/",$component,$matches);
	    $mult_res[$step][$matches[1]] = $matches[2];
	    if (count($variables)<count($components)) $variables[] = $matches[1];
	}
    }
    
    foreach ($variables as $var) {
	$result .= "$var:";
	$result .= round(MULTIPLIER*($mult_res['curr'][$var] - $mult_res['prev'][$var]) / ($counter['prev'][1]/2+$counter['curr'][1]/2+REFRESH_INTERVAL),2)." ";
    }
    
    $result = trim($result)."\n";
    
} else { //single data value

    $result=round(MULTIPLIER*($counter['curr'][0] - $counter['prev'][0]) / ($counter['prev'][1]/2+$counter['curr'][1]/2+REFRESH_INTERVAL),2)."\n";

}

echo $result;

?>
