<?php

/*
 * ZOND plugin initialization
 *
 * generates java-applet parameters,
 * prepares tasks to zond_process.php
 *
 * by johnrembo@netzond.com
 */

chdir('../../');

if (file_exists("./include/global.php"))
    @include("./include/global.php");
else
    @include("./include/config.php");

if (isset($_SERVER['argc']) && $_SERVER['argc'] == 0) {
    $guest_account = false;
    @include_once("./include/auth.php");
}
@include_once("./lib/rrd.php");
@include_once("./lib/utility.php");
@include_once("./lib/api_graph.php");
@include_once("./lib/api_tree.php");
@include_once("./lib/api_data_source.php");
@include_once("./lib/template.php");
@include_once("./lib/html_tree.php");
@include_once("./lib/html_form_template.php");
@include_once("./lib/data_query.php");
@include_once("./lib/cdef.php");
@include_once("./lib/functions.php");
chdir('plugins/zond/');
@include_once("./rpn_calc.php");
@include_once("./zond_functions.php");

//check_ini_vars();

//some config options
foreach ($zond_config_params as $zcp) {
    eval("\$$zcp=read_config_option('zond_$zcp');");
}

if (count($_REQUEST)>0) {
    input_validate_input_number(get_request_var("lgid"));
    $local_graph_id = get_request_var("lgid");
    if (check_string(get_request_var("s_i_d"))) {
	ini_set("session.auto_start",0);
	session_write_close();
	session_id(get_request_var("s_i_d"));
	session_start();
	if (!isset($_SESSION['sess_user_id']) && $security=='0') {
	    cacti_log("ERROR: User not authorised for session id (".session_id().") received from ".$_SERVER['REMOTE_ADDR'], false, "ZOND");
	    err_to_browser("Non-existing session id!");
	} else {
	    $user_id = db_fetch_cell('select username from user_auth where id = '.$_SESSION['sess_user_id']);
	    cacti_log("User \"$user_id\" initiated ZOND on graph <b>$local_graph_id</b>", false, "ZOND");
	}
    }
} else if ( isset($_SERVER['argc']) && $_SERVER['argc']>1 ) {
    input_validate_input_number($_SERVER['argv'][1]);
    $local_graph_id = $_SERVER['argv'][1];
} else {
    die ("error: not enough arguments!\n");
}

$y_min = 0;
$y_max = 0;

//load template
$zt=db_fetch_cell("select value from settings where name='zond_templates'");
if (!@include("templates/$zt.php")) include("templates/DEFAULT.php");
//determine zone used(sw or ne)
$zz=isset($t['sw_params']) ? 'sw' : 'ne';

//we need all local_data_ids associated with current local_graph_id
//COMMENTS - > COMMENT#1
$l_d_i=db_fetch_assoc('select
			data_template_rrd.id as id,
            		data_template_rrd.local_data_id,
		        data_template_rrd.data_source_type_id,
			data_template_rrd.data_source_name,
			data_template_rrd.data_input_field_id,
			graph_templates_graph.lower_limit,
			graph_templates_graph.upper_limit,
			graph_templates_graph.auto_scale,
			graph_templates_graph.auto_scale_opts
			from
			graph_templates_item
			left join data_template_rrd on (graph_templates_item.task_item_id=data_template_rrd.id)
			left join graph_templates_graph on (graph_templates_graph.local_graph_id = graph_templates_item.local_graph_id)
			where (graph_templates_item.local_graph_id='.$local_graph_id.' and local_data_id <> "")
			group by data_template_rrd.id order by sequence
		    ');
//print_r($l_d_i);

//each local_data_id has it's own poller_items
//COMMENTS - > COMMENT#2
foreach ($l_d_i as $ldi) {
    $local_data_id=$ldi['local_data_id'];
    $ds_type=$ldi['data_source_type_id'];
    $poller_items = db_fetch_assoc("select 
				    ".$ldi['id']." as 'id',
				    local_data_id, 
        			    host_id,
				    action,
				    hostname,
		            	    snmp_community, 
		    		    snmp_version, 
		            	    snmp_port, 
		            	    snmp_timeout, 
		            	    rrd_name, 
		            	    rrd_path, 
		            	    arg1 
		    		    from poller_item where local_data_id='$local_data_id'");
    
    //assign scripts and queries to apropriate fields
    foreach ($poller_items as $id => $value) {
    if ($value['rrd_name'] != '' && $value['rrd_name'] != $ldi['data_source_name']) continue;
	preg_match("/(.*)[\/\\\](.*)\.rrd/",$value['rrd_path'],$mtch);	//retrieve rrd file name without extension
	$rrdpth = $mtch[2];
	$value['rrd_name'] = $value['rrd_name'] == '' ? $ldi['data_source_name'] : $value['rrd_name'];
	$value['uniq'] = $value['id']."::".$value['rrd_name']."::".$rrdpth;
	
	if (!stristr($value['arg1'],'/')) { 				//is SNMP query
	    $queries[$value['uniq']] = $value['hostname']." ".$value['snmp_community']." ".$value['arg1']." $ds_type".($value['snmp_version']!=2 ? " v=".$value['snmp_version'] : '').($value['snmp_port']!=161 ? " p=".$value['snmp_port'] : '').($value['snmp_timeout']!=500 ? " t=".$value['snmp_timeout'] : '');
	} else { 							//is COMMAND or SCRIPT-SERVER-COMMAND
	    $queries[$value['uniq']] = $value['arg1'];
	    if ($ldi['data_input_field_id']>0) 
		$tasks[$value['uniq']]['match'] = db_fetch_cell("select data_name from data_input_fields where id = ".$ldi['data_input_field_id']);
	}

	$tasks[$value['uniq']]['type']=$ds_type; 			//0-gauge, 1 - traffic
	$tasks[$value['uniq']]['method']=$value['action'];		//1-script, 0-snmp or 2-php-script-server
	$tasks[$value['uniq']]['query']=$queries[$value['uniq']];
    }
    
    $y_min = $ldi['lower_limit'] < $y_min ? $ldi['lower_limit'] : $y_min;
    $y_max = $ldi['upper_limit'] > $y_max ? $ldi['upper_limit'] : $y_max;
}

//print_r($tasks);die;

//generate rrd command and catch the output.
define("MAX_DISPLAY_PAGES", 21);

$graph_data_array['output_flags']=2;
$graph_data_array['print_source']=1;

ob_start();
    echo rrdtool_function_graph($local_graph_id, 1, $graph_data_array);
    $rrd_cmd = ob_get_contents();
ob_end_clean();
//print_r($rrd_cmd);//die;

$rrd_cmd = explode(" \\\n",$rrd_cmd);

//parse rrd-tool command to gather all required parameters of java-applet. Calculate cdefs here as well.
foreach ($rrd_cmd as $value) {

    $value=trim($value);

    if (preg_match('/--title=(.*)/',$value,$ttl)) {
	$structure['graph_info']['title'] = clean($ttl[1]);
	continue;
    }
    
    if (preg_match('/--base=(.*)/',$value,$bs)) {
	$structure['graph_info']['base'] = $bs[1];
	continue;
    }
    
    if (preg_match('/--height=(.*)/',$value,$h)) {
	$structure['graph_info']['height'] = $h[1];
	continue;
    }
    
    if (preg_match('/--width=(.*)/',$value,$w)) {
	$structure['graph_info']['width'] = $w[1];

	continue;
    }

    if (preg_match('/--vertical-label="(.*)"/',$value,$vr)) {
	$structure['graph_info']['vertical-label'] = clean($vr[1]);
	continue;
    }
    
    //COMMENTS - > COMMENT#3
    if (preg_match('/^DEF\:(.*)=\"(.*)rra\/(.*).rrd\"\:(.*)\:/',$value,$matches0)) {
	$structure[$matches0[1]]['data_name']=assoc(array_keys($tasks),$matches0[4]."::".$matches0[3]);
	continue;
    }
    
    //COMMENTS - > COMMENT#4
    if (preg_match('/^CDEF\:(.*)=(.*)/',$value,$matches1)) {
	$cdef_comp = cdef_components($matches1[2]);
	
	if (count($cdef_comp)==1) {
	    $structure[$cdef_comp[0]]['cdef_string']=$matches1[2];
	    $structure[$cdef_comp[0]]['cdef_name']=$matches1[1];
	} else {
	    $structure[$matches1[1]]['cdef_string']=$matches1[2];
	}
	continue;
    }
    
    //COMMENTS - > COMMENT#5
    if (preg_match('/^(AREA|LINE\d?)\:(.*)\#(.*)\:"(.*)"\:?(STACK)?/',$value,$matches2)) {
	//update existing array of defs and cdefs with aditional parameters

//	print_r($matches2);
	foreach ($structure as $str_id => $str_name) {
//		echo "str_id=$str_id\t\$matches2[2]=".$matches2[2]."\n";
	    if ( 
		($str_id == $matches2[2] && !isset($structure[$str_id]['color'])) || 
		(isset($structure[$str_id]['cdef_name']) && $structure[$str_id]['cdef_name'] == $matches2[2]) ||
		(stristr($str_id,'cdef')) 
		)
		{
			
		if (empty($matches2[3])) continue;
		if (!isset($tasks['PRINT'])) $tasks['PRINT']=array();
		
		if (stristr(strtolower($matches2[1]),'line')==true) 
		    $plot_type='line';
		else
		    if ($charttype == 1) $plot_type='bars';
		else 
		    $plot_type = ($charttype == 1) ? $plot_type='bars' : 'plot';
		
		if ( isset($matches2[5]) && $matches2[5]=='STACK' ) 
		    $structure[$str_id]['plot_type'] = "stack-$plot_type";
		else 
		    $structure[$str_id]['plot_type'] = $plot_type;
		
		if ( stristr($structure[$str_id]['plot_type'],'line') ) {
			preg_match('/[0-3]/',$matches2[1],$line_width);
			$structure[$str_id]['line_width'] = $line_width[0];
		}
		
		$structure[$str_id]['color'] =  hex2dec($matches2[3]);
		$structure[$str_id]['title'] =  clean($matches2[4]);
		
		if (isset($structure[$str_id]['cdef_name']) && $matches2[2] == $structure[$str_id]['cdef_name'] && !in_array($str_id,$tasks['PRINT'])) {
		    $tasks['PRINT'][]=$str_id;
		} elseif (
			    (isset($structure[$str_id]['cdef_name']) && $matches2[2] != $structure[$str_id]['cdef_name'] && !in_array($matches2[2],$tasks['PRINT'])) ||
			    (!isset($structure[$str_id]['cdef_name']) && !in_array($matches2[2],$tasks['PRINT']))
			    ) {
		    $tasks['PRINT'][]=$matches2[2];
		}

	    }
	}
	continue;	
    }
}

//print_r($structure);//die;

//minimize everything to array containing commands,cdefs and cdef definitions map:
//COMMENTS - > COMMENT#6

//cdef's to be calculated before returning data to java-applet
$i=0;
foreach ($structure as $id => $value) {
    if ( !stristr($id,'cdef') && ($id != 'graph_info') ) {
	if (isset($structure[$id]['cdef_string']))
	    $tasks[$structure[$id]['data_name']]['cdef'] = $structure[$id]['cdef_string'];
	    $tasks['MAP'][$structure[$id]['data_name']] = $id;
    } elseif (stristr($id,'cdef')) {
	$tasks[$id] = $structure[$id]['cdef_string'];
    //graph_info array
    } else {
	continue;	
    }
    
}

//print_r($tasks);die;
//prepare tasks for zond_process.php
if (!isset($tasks)) err_to_browser("no data on this graph!");

$tasks=encode_base64(serialize($tasks));

if ($hashed=='0')
    $tasks=scatter($tasks,$hash,adopt_hbs(strlen($tasks),$hash_blck_size[$hash_blcksize]));

//prepare applet parameters
if ( $autosize=='0' ) $width = $structure['graph_info']['width'] + 100;

//generate hyperlink for data retrieval
$path = $PROTO.
	((!empty($user)) ? $user.":" : '').((!empty($pass)) ? $pass."@" : '').
	(isset($_SERVER['HTTP_HOST']) ? $_SERVER['HTTP_HOST'] : 'H_O_S_T').
	$config['url_path']."plugins/zond/";

$strings='';
$text_unit_width = floor (6*(($font_size/1.4)+2)) ; //width of single symbol group 999.99 (5-digits and 1 symbol)
$legend_area_width = $legend_area_width_dyn = $width - ($font_size+2)*3 - $text_unit_width;

//title analysis to determine if it is traffic mode (applet measures kbps mbps etc...) or not
if (preg_match("/(bit|byt|bps)/i",$structure['graph_info']['vertical-label'])) {
    $label = ' ';
    $dimension = $structure['graph_info']['vertical-label'];
    $traffic_mode='true';
    $round = $t[$zz.'_params']['round_digits'];
    $do = $t['data_params']['dimension_open'];
    $dc = $t['data_params']['dimension_close'];
} else {                                                           
    $label = $structure['graph_info']['vertical-label'];
    $dimension = '';
    $traffic_mode='false';
    $round = '0';
    $do='';
    $dc='';    
}

//print_r($structure);die;

$i=0;

foreach ($structure as $id => $item) {
    if ($id == 'graph_info' || (count($item)==1 && isset($item['data_name'])) ) continue;
    if (count($item)<3) {
	$gt_id = db_fetch_cell("select graph_template_id from graph_templates_graph where local_graph_id = $local_graph_id");
	err_to_browser("could not parse graph template (<a target=_blank href=\"graph_templates.php?action=template_edit&id=$gt_id\">$gt_id</a>)");
    }
    
    $old_col = $old_col_star = $old_col_end = false;
    $opacity = $item['plot_type'] == 'line' ? 255 : $t[$zz.'_string']['alpha_transparnc']; //lines should be opaque
    $region_gradiance = ( $t[$zz.'_string']['fill_color_start'] == $t[$zz.'_string']['fill_color_end'] || 
			  $item['plot_type']=='line'
			 ) ? false 
			 : true; //plots and bars can be gradient (if fill_color_start!=fill_color_end)

    // detect if gradient plots and bars are used, then adopt colors accordingly, by checking against existing colors and updating existing color array with new values.
    if (!$region_gradiance) {
	if ( !$old_col=present($item['color'],$t['colors']) ) {
	    $t['colors'][] = $item['color'];
	    $s=$e=last_key($t['colors']);
	} else { 
	    $s=$e=$old_col;
	}
    } else {
    	$end = darken($item['color'],10);
	$start = lighten($item['color'],10);

	if ( $old_col_end = present($end,$t['colors']) ) {
	    $e = $old_col_end;
	} else {
	    $t['colors'][] = $end;
	    $e = last_key($t['colors']);
	}

	if ( $old_col_start = present($start,$t['colors']) ) {
	    $s = $old_col_start;
	} else {
	    $t['colors'][] = $start;
	    $s = last_key($t['colors']);
	}
    }

    //applet parameter pre-initialization
    $item_strings[]	=	array(
					"data_source_id"	=>	$i,
					"chart_type"		=>	$item['plot_type'],				// line\plot\bars\ stack-line\stack-plot\stack-bars
					"fill_color_start"	=>	$s,
					"fill_color_end"	=>	$e,
					"alpha_transparnc"	=>	$opacity,					// [0-255]
					"smooth_edges"		=>	$t[$zz.'_string']['smooth_edges'],		// ture\false
					"show_details"		=>	$t[$zz.'_string']['show_details'],		// ture\false
					"name_in_lgd"		=>	$item['title'],
					"units_in_lgd"		=>	$t[$zz.'_string']['units_in_lgd'],		// ture\false
					"curr_val_in_lgd"	=>	$t[$zz.'_string']['curr_val_in_lgd'],
					"line_type"		=>	$t[$zz.'_string']['line_type'],
					"line_width"		=>	(isset($item['line_width']) ? $item['line_width'] : 1),
					"on_chart_values"	=>	$t[$zz.'_string']['on_chart_values'],
					"darken_contours"	=>	($item['plot_type'] == 'line') ? 'false' : $t[$zz.'_string']['darken_contours'],
					"hide_data_source"	=>	"false"
				    );

    $legend_widths[] = floor( ( strlen($item['title'])+1 + (strlen($label) + strlen($dimension)) + 7 ) * ($font_size/1.14) + $text_unit_width * 4) + 9;//whole legend width
    $i++;
}

$stacked_widths = 0;
$legends_per_line = 0;
$lpl=array();

foreach ($legend_widths as $lwidth) {
    if ( ($stacked_widths + $lwidth) < $legend_area_width ) {
	$stacked_widths += $lwidth;
	$legends_per_line++;
    } else {
	$stacked_widths = $lwidth;
	$lpl[]=$legends_per_line;
	$legends_per_line=1;
    }
}

rsort($lpl,SORT_NUMERIC);
if (count($lpl)>0) $legends_per_line = $lpl[0];

if ($legends_per_line == 0) $legends_per_line = 1;
$legend_rows_count = floor($i/$legends_per_line);
$legend_rows_count = ( $legend_rows_count == $i/$legends_per_line ) ? $legend_rows_count : $legend_rows_count++;
$scale_type = read_config_option("zond_scaletype");

if ( $autosize=='0' ) $height = $structure['graph_info']['height'] + 90 + $legend_rows_count * round($font_size / 1.14+5);

if ($scale_type == 0) {//CACTI scale
    $cacti_auto_scale = $ldi['auto_scale'] != "" ? true : false;
    if ($cacti_auto_scale) {
	$cacti_auto_scale_max = $ldi['auto_scale_opts'] == '2' ? true : false;
	if ($cacti_auto_scale_max) {
	    $y_fixed_min = 'true';	//min = 0
	    $y_fixed_max = 'false';	//max = auto
	} else {//same as ZOND scale
	    $y_fixed_min = 'false';	//min = auto
	    $y_fixed_max = 'false';	//max = auto
	}
    } else {//fixed cacti scale
	$y_fixed_min = 'true';	//min = auto
	$y_fixed_max = 'true';	//max = auto
    }
} else {//ZOND scale
    $y_fixed_min = 'false';	//min = auto
    $y_fixed_max = 'false';	//max = auto
}

//in case of "dynamic" window size - we must resize it depending on apropriate cacti's chart height and width
if ($autosize=='0') {
$script =  " <SCRIPT LANGUAGE=javascript>
    function resize_window(w,h) {
	var refresh=2;
	var wW = screen.width;
	var wH = screen.height;

	while (1) {

	    if ( document.body && ( document.body.clientWidth || document.body.clientHeight ) ) {
		var ww = document.body.clientWidth;
		var wh = document.body.clientHeight;
	    } else {
		var ww = window.innerWidth;
		var wh = window.innerHeight;
	    }

            var diff_w = Math.round((w - ww)/refresh);
            var diff_h = Math.round((h - wh)/refresh);
	    
            if (diff_w <1 && diff_h <1) {
	    	self.resizeBy(diff_w,diff_h);
		self.moveTo((wW-ww)/2,(wH-wh)/2);
                return;
            }
	    
	    self.moveTo((wW-ww)/2,(wH-wh)/2);
            self.resizeBy(diff_w,diff_h);
	}
    }
 </SCRIPT>";
$load = "onLoad=\"resize_window($width,$height)\"";
} else {
 $script = "";
 $load = "";
}

//initialize applet parameters
foreach ($item_strings as $id => $str_group)
    $item_strings[$id] = implode(",",$str_group);

$item_strings = implode(";",$item_strings);

$a=array(
	"data_params"	=>	array(
					"top_scale_type"	=>	"time",
					"bot_scale_type"	=>	"time",
					"time_format"		=>	$t['data_params']['time_format'],
					"dimension_open"	=>	$t['data_params']['dimension_open'],
					"dimension_close"	=>	$t['data_params']['dimension_close']
				    ),
	$zz.'_params'	=>	array(
					"units"			=>	$dimension,
					"factor"		=>	$structure['graph_info']['base'],
					"round_digits"		=>	$t['sw_params']['round_digits'],
					"traffic_mode"		=>	$traffic_mode,
					"fixed_max_scale"	=>	$y_fixed_max,
					"max_scal_val"		=>	$y_max,
					"fixed_min_scale"	=>	$y_fixed_min,
					"min_scal_val"		=>	$y_min,
					"val_area_size"		=>	$t['sw_params']['val_area_size']
				    ),
	"outer_params"	=>	array(
					"border_width"		=>	$t['outer_params']['border_width'],
					"line_spacing"		=>	$t['outer_params']['line_spacing'],
					"font"			=>	$t['outer_params']['font'],
					"font1_size"		=>	$t['outer_params']['font1_size'], 
    					"font2_size"		=>	$t['outer_params']['font2_size'],
					"font3_size"		=>	$t['outer_params']['font3_size'],
					"grapt_title_top"	=>	$structure['graph_info']['title'],
					"graph_title_bot"	=>	$t['outer_params']['graph_title_bot'],
					"axis_title_top"	=>	$t['outer_params']['axis_title_top'],
					"axis_title_bot"	=>	$t['outer_params']['axis_title_bot'],
					"axis_title_left"	=>	$label,
					"axis_title_right"	=>	$t['outer_params']['axis_title_right'],
					"indicator"		=>	$t['outer_params']['indicator'],
					"refresh_interval"	=>	$refresh,
					"data_source"		=>	$path."zond_process.php?s_i_d=".session_id()."&tasks=".$tasks
				    ),
	"inner_params"	=>	array(
					"step"			=>	$t['inner_params']['step'],
					"horz_inner_margin"	=>	$t['inner_params']['horz_inner_margin'],
					"vert_inner_margin"	=>	$t['inner_params']['horz_inner_margin'],
					"maj_vert_grid_dens"	=>	$t['inner_params']['maj_vert_grid_dens'],
					"min_vert_grid_dens"	=>	$t['inner_params']['min_vert_grid_dens'],
					"maj_horz_grid_dens"	=>	$t['inner_params']['maj_horz_grid_dens'],
					"min_horz_grid_dens"	=>	$t['inner_params']['min_horz_grid_dens'],
					"bot_index_display"	=>	($axis_pos==0 ? -1 : 0),
					"top_index_display"	=>	($axis_pos==0 ? 0 : -1),
					"right_axis"		=>	$traffic_mode,
					"left_axis"		=>	"true",
					"rotated_bot_axis"	=>	$t['inner_params']['rotated_bot_axis'],
					"rotated_top_axis"	=>	$t['inner_params']['rotated_top_axis'],
					"indicator_type"	=>	$t['inner_params']['indicator_type'],
					"indicator_width"	=>	$t['inner_params']['indicator_width'],
					"legend_spacing"	=>	$t['inner_params']['legend_spacing'],
					"legend_per_line"	=>	($t['inner_params']['legend_per_line']==1 ? 1 : $legends_per_line),
					"legend_layout"		=>	$t['inner_params']['legend_layout'],
					"retain_axis_colors"	=>	$t['inner_params']['retain_axis_colors']
				    ),
	"color_map"	=>	array(
					"gr_border_start"	=>	$t['color_map']['gr_border_start'],
					"gr_border_end"		=>	$t['color_map']['gr_border_end'],
					"gr_backg_start"	=>	$t['color_map']['gr_backg_start'],
					"gr_backg_end"		=>	$t['color_map']['gr_backg_end'],
					"gr_title"		=>	$t['color_map']['gr_title'],
					"min_grid"		=>	$t['color_map']['min_grid'],
					"maj_grid"		=>	$t['color_map']['maj_grid'],
					"chart_border"		=>	$t['color_map']['chart_border'],
					"axis_val"		=>	$t['color_map']['axis_val'],
					"on-chart_val"		=>	$t['color_map']['on-chart_val'],
					"indicator"		=>	$t['color_map']['indicator'],
					"legend"		=>	$t['color_map']['legend'],
					"axies_labels"		=>	$t['color_map']['axies_labels'],
					"chart_backg_start"	=>	$t['color_map']['chart_backg_start'],
					"axies_backg_end"	=>	$t['color_map']['chart_backg_end'],
					"label_rect_border"	=>	$t['color_map']['label_rect_border']
				    )
    );

foreach ($a as $id => $item)
    $a[$id] = implode(",",$item);
//print_r($t['colors']);//die;
$a['colors'] = implode(";",$t['colors']);

echo "<HTML>
 <HEAD>
    <TITLE>".$structure['graph_info']['title']."</TITLE>
 </HEAD>
 $script
 <BODY $load style='background-color:#F9F9F9;margin:0'>
 <APPLET id = 'applet' codebase='".$path."' code='netzond.class' width=$width height=$height'>
    <PARAM name='dataParams' value='".$a['data_params']."'>
    <PARAM name='".strtoupper($zz)."Params' value='".$a[$zz.'_params']."'>
    <PARAM name='outerParams' value='".$a['outer_params']."'>
    <PARAM name='innerParams' value='".$a['inner_params']."'>
    <PARAM name='colorParams' value='".$a['colors']."'>
    <PARAM name='objcolsParams' value='".$a['color_map']."'>
    <PARAM name='${zz}String' value='".$item_strings."'>
 </APPLET>
 </BODY>
</HTML>
";

?>
