<?php

/*
 * ZOND plugin data gathering for the java-applet
 * by johnrembo@netzond.com
 */
chdir('../../');
if (file_exists("./include/global.php"))
    @include("./include/global.php");
else
    @include("./include/config.php");
@include_once("./lib/utility.php");
@include_once("./lib/rrd.php");
@include_once("./lib/api_graph.php");
@include_once("./lib/api_tree.php");
@include_once("./lib/api_data_source.php");
@include_once("./lib/template.php");
@include_once("./lib/html_tree.php");
@include_once("./lib/html_form_template.php");
@include_once("./lib/data_query.php");
@include_once("./lib/cdef.php");chdir('plugins/zond/');
@include_once("./rpn_calc.php");
@include_once("./zond_functions.php");

foreach ($zond_config_params as $zcp) {
    eval("\$$zcp=read_config_option('zond_$zcp');");
}

if (count($_REQUEST)>0) {
    $tasks = get_request_var("tasks");
    $s_i_d = get_request_var("s_i_d");
    if ( $security=='0' && $s_i_d != '' && check_string($s_i_d) ) {
        ini_set("session.auto_start",0);
        @session_write_close();
        @session_id($s_i_d);
        @session_start();
        if (!isset($_SESSION['sess_user_id'])) {
            cacti_log("ERROR: User not authorised for session id (".session_id().") received from ".$_SERVER['REMOTE_ADDR'], false, "ZOND");
            die("Non-existing session id!\n");
        }
    }
    if ( $security == '1' && (!isset($_SERVER['HTTP_USER_AGENT']) || !stristr($_SERVER['HTTP_USER_AGENT'],'java')) ) {
        cacti_log("ERROR: Current configuration does not allow direct access to ZOND for <a title=\"".$_SERVER['HTTP_USER_AGENT']."\">application</a> from location from ".$_SERVER['REMOTE_ADDR'], false, "ZOND");
	header("Location:../index.php");
	die;
    }
} else if (isset($_SERVER['argc']) && $_SERVER['argc']>1) {
    check_string($_SERVER['argv'][1]);
    $tasks = $_SERVER['argv'][1];
} else {
    die ("not enough parrameters!\n");
}

if ($hashed=='0')
    $tasks = scatter($tasks,$hash,adopt_hbs(strlen($tasks),$hash_blck_size[$hash_blcksize]),false);

$req = unserialize(decode_base64($tasks));
//print_r($req);die;

$previous = '';
$multi_record_script = false;

//launch data collecting
foreach ($req['MAP'] as $id => $val) {
    if ( !isset($req[$id]['query']) ) 
	continue;
    
    if ( isset($req[$id]['match']) && ($req[$id]['query'] == $previous) ) {
	$multi_record_script = true;
	continue;
    }
    
    if ($req[$id]['method'] != 0) {			//fork command
	if ($req[$id]['type'] == 1) {			//script output is GAUGE
	    if ($req[$id]['method'] == 1) {		//shell command 
		if (stristr($req[$id]['query'],'.php') && !stristr($req[$id]['query'],$php_bin_path) )
		    $req[$id]['query'] = "$php_bin_path -q".$req[$id]['query'];
    		$fh[$id] = popen($req[$id]['query'],"r");
	    }else{ 					//php script server command
		$tsk = explode(" ",$req[$id]['query']);
		$fh[$id] = popen("$php_bin_path -q ".str_replace(" ".$tsk[1],'',$req[$id]['query']),"r");
	    }
	} else {					//script output is COUNTER
	    $fh[$id] = popen("$php_bin_path -q traffic.php \"".str_replace('$','\$',$req[$id]['query'])."\"","r");
	}
    } else {						//fork snmp-get (query allready contains counter/gauge descriptor, no need to check TYPE)
        $fh[$id] = popen("$php_bin_path -q snmp.php ".$req[$id]['query'],"r");
    }
    
    $previous = $req[$id]['query'];
}

//fetch collected values
foreach ($fh as $id => $value) {
	$output[$id] = '';
	if ($value) {
	    while ($data = fgets($value)) 
		$output[$id] .= $data;
	    pclose($value);
	    $output[$id] = trim($output[$id]);
	}

	$req['VALS'][ $req['MAP'][$id] ] = $output[$id];
	
	if ( stristr($output[$id],":") && !($multi_record_script) ) $multi_record_script = true;
}

//print_r($req['VALS']);

//match collected values agains their names
if ($multi_record_script) {
    foreach ($req['VALS'] as $id => $value) {
	if (substr_count($value," ")>0) //if multi-output value found
	    foreach (explode(" ",$value) as $single_output) //split strings into array
	    	foreach ($req as $id2 => $value2) //assing certain values to to apropirate DEFs by checking [match] agains single_output
		if ( isset($value2['match']) && preg_match("/^(".$value2['match']."):([-+]?[0-9]*\.?[0-9]+)$/i",$single_output,$matches) ) {
		    //save matched values
		    $req['VALS'][$req['MAP'][$id2]] = $matches[2];
		    $output[$id2] = $matches[2];
		}
    }
}
//print_r($output);
//print_r($req['VALS']);

//calculate virtual cdefs before applying rpn_calc to real cdefs.
foreach ($req as $cdef => $value)
    if (stristr($cdef,'cdef'))
	$output[$cdef] = rpn_calc(str_replace(array_keys($req['VALS']),array_values($req['VALS']),$req[$cdef]));

//real cdefs
foreach ($req as $id => $value) {
    if ( is_array($req[$id]) && isset($req[$id]['cdef']) && !stristr($id,'MAP')  && !stristr($id,'VALS') ) 
        $output[$id] = (rpn_calc(str_replace( $req['MAP'][$id],$output[$id],$req[$id]['cdef'] )));
}
//print_r($output);
//print_r($req);die;

//remove values that have been used in cdef calculation only
foreach ($output as $key => $val)
    if ( 
	( substr($key,0,4)=='cdef' && !in_array($key,$req['PRINT']) ) ||
	( isset($req['MAP'][$key]) && !in_array($req['MAP'][$key],$req['PRINT']) )
    	)
	    unset($output[$key]);

//sort output as defined in graph template
if ( count($output) > 1 )  {
    foreach ($req as $id => $value) {
	if ( $id != 'MAP' && $id != 'VALS' )
	    if ( isset($output[$id]) ) 
		$sorted_output[$id] = $output[$id];
    }
    $output = $sorted_output;
}

/*
    this replace eliminates UN problem in the applet (applet can work only with integers)
    but it causes problems when UNs appear and dissapear:
    (xxxxxx[current value]-0[UN -previuos value])/time=xxxxxx/time - applet starts dispalying nonsenses
*/
//print_r($output);die;

echo str_replace( 'UN','0',implode("\n",$output) );

?>
